#define TM_JSON_IMPLEMENTATION
#include "tm_json.h"

#include <stdio.h>

void TestJSON( char* filename ){
	FILE* file = fopen( filename, "r" );
	if( file == NULL ){
		fprintf( stderr, "Failed to open %s\n", filename );
		return;
	}
	char text[1024 * 1024]; // A megabyte should be enough for everyone.
	size_t num_chars = fread( text, 1, sizeof( text ), file );
	fclose( file );

	printf( "%s is %lu characters long\n", filename, num_chars );

	JsonAllocatedDocument allocatedDocument =
		jsonAllocateDocument( text, num_chars, JSON_READER_JSON5 );

	JsonDocument doc = allocatedDocument.document;
	if( doc.error.type != JSON_OK ){
		fprintf(
			stderr,
			"JSON ERROR: %s at line %lu:%lu\n",
			jsonGetErrorString( doc.error.type ),
			doc.error.line,
			doc.error.column
		);
	}

	jsonFreeDocument( &allocatedDocument );
}

int main(){
	TestJSON( "test1.json" );
	TestJSON( "test2.json" );
	return 0;
}
